> ## Documentation Index
> Fetch the complete documentation index at: https://developer.fabric.inc/llms.txt
> Use this file to discover all available pages before exploring further.

# Add a new customer

> Using this endpoint, you can add a new customer to the system. The response includes an `id` which is required in subsequent calls, such as `GET /customers/{customerId}`, `PUT /customers/{customerId}`, `PATCH /customers/{customerId}`, and more. <br /> When `externalId` is specified, the customers have the ability to manage their own details through the storefront UI.



## OpenAPI

````yaml customers.openapi post /Customers
openapi: 3.0.0
info:
  title: Customers
  description: >-
    The fabric **Customers** API is used to create and manage details of
    storefront customers, also referred to as shoppers. The `Customers` or
    `Customer Address` APIs provide features for store admins to manage their
    customers' details and addresses. The `Customer Self' API provide features
    for customers or shoppers to independently manage their own details.
  version: 3.0.0
  x-audience: external-public
  contact:
    name: fabric Support
    email: support@fabric.inc
  license:
    name: fabric API License
    url: https://fabric.inc/api-license
  termsOfService: https://fabric.inc/terms-of-use
servers:
  - url: https://api.fabric.inc/v3
    description: Production
security:
  - bearerAuth: []
tags:
  - name: Customer Profile
    description: >-
      These endpoints provide the features for store admins to create and manage
      customers' details.
  - name: Customer Address
    description: >-
      These endpoints provide the features for store admins to create and manage
      customers' addresses.
  - name: Customer Self
    description: >-
      These endpoints provide the feature for customers or shoppers to
      independently manage their details in the storefront.
paths:
  /Customers:
    post:
      tags:
        - Customer Profile
      summary: Add a new customer
      description: >-
        Using this endpoint, you can add a new customer to the system. The
        response includes an `id` which is required in subsequent calls, such as
        `GET /customers/{customerId}`, `PUT /customers/{customerId}`, `PATCH
        /customers/{customerId}`, and more. <br /> When `externalId` is
        specified, the customers have the ability to manage their own details
        through the storefront UI.
      operationId: createCustomer
      parameters:
        - $ref: '#/components/parameters/xFabricTenantId'
        - $ref: '#/components/parameters/xFabricRequestId'
      requestBody:
        description: A sample request to add a new customer.
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/createCustomerRequest'
        required: true
      responses:
        '201':
          description: OK
          headers:
            x-fabric-request-id:
              $ref: dae96e30-e72e-4091-be69-ce7f63e78aa2
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/createCustomerResponse'
        '400':
          $ref: '#/components/responses/badRequest'
        '403':
          $ref: '#/components/responses/forbidden'
        '500':
          $ref: '#/components/responses/internalServerError'
components:
  parameters:
    xFabricTenantId:
      name: x-fabric-tenant-id
      in: header
      description: >-
        A header used by fabric to identify the tenant making the request. You
        must include tenant id in the authentication header for an API request
        to access any of fabric’s endpoints. You can retrieve the tenant id ,
        which is also called account id, from
        [Copilot](/v3/platform/settings/account-details/getting-the-account-id).
        This header is required.
      schema:
        type: string
        example: 517fa9dfd42d8b00g1o3k312
    xFabricRequestId:
      name: x-fabric-request-id
      in: header
      description: A UUID of the request.
      schema:
        type: string
      example: 263e731c-45c8-11ed-b878-0242ac120002
      required: false
  schemas:
    createCustomerRequest:
      type: object
      required:
        - name
        - emailAddress
      properties:
        name:
          $ref: '#/components/schemas/commonName'
        emailAddress:
          type: string
          description: The customer's email.
          format: email
          example: test@example.com
        phone:
          $ref: '#/components/schemas/phone'
        externalId:
          type: string
          description: A UUID of the customer.
          example: 1231012312-312-31231asda
        additionalAttributes:
          description: A placeholder for additional info, in key-value pairs.
          type: object
          example:
            type: shopper
    createCustomerResponse:
      required:
        - id
        - isDeleted
        - createdAt
        - updatedAt
        - name
        - emailAddress
      type: object
      properties:
        id:
          type: string
          description: A 24-character system-generated customer ID.
          uniqueItems: true
          example: 61df41892bf06d00092d0d8a
        name:
          $ref: '#/components/schemas/commonName'
        status:
          description: The status of the customer.
          type: string
          enum:
            - ACTIVE
            - INACTIVE
            - BLOCKED
          example: ACTIVE
        emailAddress:
          type: string
          description: The customer's email.
          format: email
          example: test@example.com
        phone:
          $ref: '#/components/schemas/phone'
        externalId:
          type: string
          description: A UUID of the customer.
          example: 1231012312-312-31231asda
        additionalAttributes:
          description: A placeholder for additional info, in key-value pairs.
          type: object
          example:
            middleName: user
        isDeleted:
          type: boolean
          description: >-
            A flag indicating whether the customer data is deleted. `true`
            indicates the customer data is deleted and `false` indicates
            otherwise.
          example: false
        deletedAt:
          description: The time when the customer data was deleted, in UTC format.
          type: string
          format: date-time
          example: '2023-08-30T23:20:42.822Z'
          nullable: true
        createdAt:
          description: The time when the customer was added, in UTC format.
          type: string
          format: date-time
          example: '2023-08-30T23:20:42.822Z'
        updatedAt:
          description: The time when the customer details were last updated, in UTC format.
          type: string
          format: date-time
          example: '2023-08-30T23:20:42.822Z'
          nullable: true
    commonName:
      type: object
      description: The full name of the customer.
      required:
        - firstName
        - lastName
      properties:
        title:
          description: The customer's title, such as Mr., Mrs, and Dr.
          type: string
          example: Dr.
        firstName:
          description: The customer's first name.
          type: string
          example: Pat
        middleName:
          description: The customer's middle name.
          type: string
          example: E
        lastName:
          description: The customer's last name.
          type: string
          example: Doe
        suffix:
          description: The suffix for the customer's name, such as Jr., PhD, and more.
          type: string
          example: Jr.
    phone:
      type: object
      properties:
        number:
          type: string
          description: The customer's phone number.
          example: 15555551234
        type:
          type: string
          description: The type of phone number.
          example: MOBILE
          nullable: true
          enum:
            - MOBILE
            - HOME
            - BUSINESS
    message:
      description: The response message.
      type: object
      properties:
        type:
          description: A machine-readable code.
          type: string
          example: SUCCESS
        message:
          description: A human-friendly message corresponding to the `type`.
          type: string
          example: Success message
      required:
        - type
        - message
  responses:
    badRequest:
      description: Bad request
      headers:
        x-fabric-request-id:
          $ref: dae96e30-e72e-4091-be69-ce7f63e78aa2
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/message'
          examples:
            invalidAccountProvided:
              value:
                type: INVALID_ACCOUNT_PROVIDED
                message: Invalid account provided for the request.
    forbidden:
      description: Forbidden Request
      headers:
        x-fabric-request-id:
          description: Unique request ID
          schema:
            type: string
            example: 263e731c-45c8-11ed-b878-0242ac120002
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/message'
          example:
            type: REQUEST_DENIED
            message: Forbidden
    internalServerError:
      description: The request is received but an internal error occurred
      headers:
        x-fabric-request-id:
          $ref: dae96e30-e72e-4091-be69-ce7f63e78aa2
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/message'
          example:
            type: INTERNAL_SERVER_ERROR
            message: Internal server error
  securitySchemes:
    bearerAuth:
      description: The access token.
      type: http
      scheme: bearer
      bearerFormat: JWT

````